cmd/xfs/tools/README.auto-qa 1.1 Renamed to cmd/xfstests/tools/README.auto-qa
[xfstests-dev.git] / common.rc
1 ##/bin/sh
2
3 #
4 # Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
5
6 # This program is free software; you can redistribute it and/or modify it
7 # under the terms of version 2 of the GNU General Public License as
8 # published by the Free Software Foundation.
9
10 # This program is distributed in the hope that it would be useful, but
11 # WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
13
14 # Further, this software is distributed without any warranty that it is
15 # free of the rightful claim of any third person regarding infringement
16 # or the like.  Any license provided herein, whether implied or
17 # otherwise, applies only to this software file.  Patent licenses, if
18 # any, provided herein do not apply to combinations of this program with
19 # other software, or any other product whatsoever.
20
21 # You should have received a copy of the GNU General Public License along
22 # with this program; if not, write the Free Software Foundation, Inc., 59
23 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
24
25 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
26 # Mountain View, CA  94043, or:
27
28 # http://www.sgi.com 
29
30 # For further information regarding this notice, see: 
31
32 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
33 #
34
35 # we need common.config
36 if ! . ./common.config
37 then
38     echo "$iam: failed to source common.config"
39     exit 1
40 fi
41
42 # awk
43 AWK_PROG=gawk
44
45 # ps
46 PS_HAVE_BSD=false
47 PS_ALL_FLAGS=-efw
48
49 # host os
50 PLATFORM=linux
51
52 # extra parameters for fsstress
53 FSSTRESS_AVOID="-f resvsp=0 -f unresvsp=0"
54
55 export AWK_PROG PS_HAVE_BSD PS_ALL_FLAGS PLATFORM
56
57 # we override mount so we can specify mount options
58
59 mount()
60 {
61     case "$*"
62     in
63         *remount*)
64             /bin/mount $*
65             ;;
66         *ext2*)
67             /bin/mount $*
68             ;;
69         *xfs*)
70             /bin/mount $* $MOUNT_OPTIONS
71             ;;
72         *)
73             /bin/mount $*
74             ;;
75     esac
76 }
77
78 #
79
80 _get_pids_by_name()
81 {
82     if [ $# -ne 1 ]
83     then
84         echo "Usage: _get_pids_by_name process-name" 1>&2
85         exit 1
86     fi
87
88     # Algorithm ... all ps(1) variants have a time of the form MM:SS or
89     # HH:MM:SS before the psargs field, use this as the search anchor.
90     #
91     # Matches with $1 (process-name) occur if the first psarg is $1
92     # or ends in /$1 ... the matching uses sed's regular expressions,
93     # so passing a regex into $1 will work.
94
95     ps $PS_ALL_FLAGS \
96     | sed -n \
97         -e 's/$/ /' \
98         -e 's/[         ][      ]*/ /g' \
99         -e 's/^ //' \
100         -e 's/^[^ ]* //' \
101         -e "/[0-9]:[0-9][0-9]  *[^ ]*\/$1 /s/ .*//p" \
102         -e "/[0-9]:[0-9][0-9]  *$1 /s/ .*//p"
103 }
104
105 # fqdn for localhost
106 #
107 _get_fqdn()
108 {
109     host=`hostname`
110     nslookup $host | $AWK_PROG '{ if ($1 == "Name:") print $2 }'
111 }
112
113 # fix malloc libs output
114 #
115 _fix_malloc()
116 {
117     # filter out the Electric Fence notice
118     perl -e '
119         while (<>) {
120             if (defined $o && /^\s+Electric Fence/) {
121                 chomp($o);
122                 print "$o";
123                 undef $o;
124                 next;
125             }
126             print $o if (defined $o);
127
128             $o=$_;
129         }
130         print $o if (defined $o);
131     '
132 }
133
134 # check if run as root
135 #
136 _need_to_be_root()
137 {
138     id=`id | sed -e 's/(.*//' -e 's/.*=//'`
139     if [ "$id" -ne 0 ]
140     then
141         echo "Arrgh ... you need to be root (not uid=$id) to run this test"
142         exit 1
143     fi
144 }
145
146
147 #
148 # _df_device : get an IRIX style df line for a given device 
149 #
150 #       - returns "" if not mounted
151 #       - returns fs type in field two (ala IRIX)
152 #       - joins line together if split by fancy df formatting
153 #       - strips header etc
154 #
155
156 _df_device()
157 {
158     if [ $# -ne 1 ]
159     then
160         echo "Usage: _df_device device" 1>&2
161         exit 1
162     fi
163     
164     df -T 2>/dev/null | $AWK_PROG -v what=$1 '
165         match($1,what) && NF==1 { 
166             v=$1
167             getline
168             print v, $0
169             exit
170         }
171         match($1,what) {
172             print
173             exit
174         }
175     '
176 }
177
178 #
179 # _df_dir : get an IRIX style df line for device where a directory resides
180 #
181 #       - returns fs type in field two (ala IRIX)
182 #       - joins line together if split by fancy df formatting
183 #       - strips header etc
184 #
185
186 _df_dir()
187 {
188     if [ $# -ne 1 ]
189     then
190         echo "Usage: _df_dir device" 1>&2
191         exit 1
192     fi
193     
194     df -T $1 2>/dev/null | $AWK_PROG -v what=$1 '
195         NR == 2 && NF==1 { 
196             v=$1
197             getline 
198             print v, $0;
199             exit 0
200         }
201         NR == 2 {
202             print;
203             exit 0
204         }
205         {}
206     '
207     # otherwise, nada
208 }
209
210 # return percentage used disk space for mounted device
211
212 _used()
213 {
214     if [ $# -ne 1 ]
215     then
216         echo "Usage: _used device" 1>&2
217         exit 1
218     fi
219     
220     _df_device $1 | $AWK_PROG '{ sub("%", "") ; print $6 }'
221 }
222
223 # return the FS type of a mounted device
224 #
225 _fs_type()
226 {
227     if [ $# -ne 1 ]
228     then
229         echo "Usage: _fs_type device" 1>&2
230         exit 1
231     fi
232     
233     _df_device $1 | $AWK_PROG '{ print $2 }'
234 }
235
236 # return the FS mount options of a mounted device
237 #
238 _fs_options()
239 {
240     if [ $# -ne 1 ]
241     then
242         echo "Usage: _fs_options device" 1>&2
243         exit 1
244     fi
245     
246     $AWK_PROG -v dev=$1 '
247         match($1,dev) { print $4 }
248     ' </proc/mounts
249     
250 }
251
252 # returns device number if a file is a block device
253 #
254 _is_block_dev()
255 {
256     if [ $# -ne 1 ]
257     then
258         echo "Usage: _is_block_dev dev" 1>&2
259         exit 1
260     fi
261     
262     [ -b $1 ] && src/lstat64 $1 | $AWK_PROG '/Device type:/ { print $9 }'
263 }
264
265 # bail out, setting up .notrun file
266
267 _notrun()
268 {
269     echo "$*" >$seq.notrun
270     status=0
271     exit
272 }
273
274 # just plain bail out
275
276 _fail()
277 {
278     echo "$*" | tee -a $seq.full
279     echo "(see $seq.full for details)"
280     status=1
281     exit 1
282 }
283
284 # this test needs a scratch partition - check we're ok & unmount it
285
286 _require_scratch()
287 {
288
289     if [ -z "$SCRATCH_DEV" -o "`_is_block_dev $SCRATCH_DEV`" = "" ]
290     then
291         _notrun "this test requires a valid \$SCRATCH_DEV"
292     fi
293     
294     if [ "`_is_block_dev $SCRATCH_DEV`" = "`_is_block_dev $TEST_DEV`" ]
295     then
296         _notrun "this test requires a valid \$SCRATCH_DEV"
297     fi
298     
299     # mounted?
300     if mount | grep -q $SCRATCH_DEV
301     then 
302         # if it's mounted, make sure its on $SCRATCH_MNT
303         if ! mount | grep $SCRATCH_DEV | grep -q $SCRATCH_MNT
304         then 
305             echo "\$SCRATCH_DEV is mounted but not on \$SCRATCH_MNT - aborting"
306             exit 1
307         fi
308         
309         # and then unmount it
310     
311         if ! umount $SCRATCH_DEV
312         then
313             echo "failed to unmount $SCRATCH_DEV"
314             exit 1
315         fi
316     fi
317     
318     # should be ok now
319
320 }
321
322 # this test needs a logdev 
323
324 _require_logdev()
325 {
326     if [ -z "$SCRATCH_LOGDEV" -o ! -b "$SCRATCH_LOGDEV" ]
327     then
328         _notrun "This test requires a valid \$SCRATCH_LOGDEV" 
329     fi
330 }
331
332 # this test requires loopback device support
333
334 _require_loop()
335 {
336     if grep loop /proc/devices >/dev/null 2>&1
337     then
338         :
339     else
340         _notrun "This test requires loopback device support"
341     fi
342 }
343
344
345 # check that a FS is mounted as XFS. if so, return mount point
346 #
347 _xfs_mounted()
348 {
349     if [ $# -ne 1 ]
350     then
351         echo "Usage: _xfs_mounted device" 1>&2
352         exit 1
353     fi
354     
355     device=$1
356     
357     if mount | grep $device | $AWK_PROG '
358         /type xfs/  { print $3 ; exit 0 }
359         END         { exit 1 }
360     '
361     then
362         echo "_xfs_mounted: $device is not a mounted XFS FS"
363         exit 1
364     fi
365 }
366
367 # remount a FS to a new mode (ro or rw)
368 #
369
370 _remount()
371 {
372     if [ $# -ne 2 ]
373     then
374         echo "Usage: _remount device ro/rw" 1>&2
375         exit 1
376     fi
377     device=$1
378     mode=$2
379     
380     if ! mount -o remount,$mode $device
381     then
382         echo "_remount: failed to remount filesystem on $device as $mode"
383         exit 1
384     fi
385     
386     # we might like to check here later
387     #options=`_fs_options $device`
388
389 }
390
391 # run xfs_check on a FS. 
392 #
393 # if the filesystem is mounted, it's either remounted ro before being
394 # checked or it's unmounted and then remounted
395 #
396
397 USE_REMOUNT=0
398
399 _check_fs()
400 {
401     if [ $# -ne 1 ]
402     then
403         echo "Usage: _check_fs device" 1>&2
404         exit 1
405     fi
406     
407     device=$1
408     type=`_fs_type $device`
409     ok=1
410     
411     if [ "$type" = "xfs" ]
412     then
413         # mounted... 
414         
415         if [ $USE_REMOUNT -eq 0 ]
416         then
417             mountpoint=`_xfs_mounted $device`
418             umount $device
419         else
420             _remount $device ro
421         fi
422     fi
423
424     xfs_logprint -t $device 2>&1 | tee $tmp.fs_check | grep -q "<CLEAN>"
425     if [ $? -ne 0 ]
426     then
427         echo "_check_fs: filesystem on $device has dirty log (see $seq.full)"
428         
429         echo "_check_fs: filesystem on $device has dirty log"   >>$seq.full
430         echo "*** xfs_logprint -t output ***"                   >>$seq.full
431         cat $tmp.fs_check                                       >>$seq.full
432         echo "*** end xfs_logprint output"                      >>$seq.full
433         
434         ok=0
435     fi
436         
437     
438     xfs_check $device 2>&1 | _fix_malloc >$tmp.fs_check 
439     if [ -s $tmp.fs_check ]
440     then
441         echo "_check_fs: filesystem on $device is inconsistent (c) (see $seq.full)"
442         
443         echo "_check_fs: filesystem on $device is inconsistent" >>$seq.full
444         echo "*** xfs_check output ***"                         >>$seq.full
445         cat $tmp.fs_check                                       >>$seq.full
446         echo "*** end xfs_check output"                         >>$seq.full
447         
448         ok=0
449     fi
450     
451     if ! xfs_repair -n $device >$tmp.fs_check 2>&1
452     then
453         echo "_check_fs: filesystem on $device is inconsistent (r) (see $seq.full)"
454         
455         echo "_check_fs: filesystem on $device is inconsistent" >>$seq.full
456         echo "*** xfs_repair -n output ***"                     >>$seq.full
457         cat $tmp.fs_check | _fix_malloc                         >>$seq.full
458         echo "*** end xfs_repair output"                        >>$seq.full
459         
460         ok=0
461     fi
462     rm -f $tmp.fs_check
463     
464     if [ $ok -eq 0 ]
465     then
466         echo "*** mount output ***"                             >>$seq.full
467         mount                                                   >>$seq.full
468         echo "*** end mount output"                             >>$seq.full
469     fi
470     
471     if [ "$type" = "xfs" ]
472     then
473         # mounted... 
474         if [ $USE_REMOUNT -eq 0 ]
475         then
476             if ! mount -t xfs $device $mountpoint
477             then
478                 echo "!!! failed to remount $device on $mountpoint"
479                 ok=0
480             fi
481         else
482             _remount $device rw
483         fi
484     fi
485     
486     [ $ok -eq 0 ] && exit 1
487     
488 }
489
490 ################################################################################
491
492 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
493 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
494
495 if [ "$iam" != new ]
496 then
497
498     # make some further configuration checks here
499     
500     if [ "$TEST_DEV" = ""  ]
501     then
502         echo "common.rc: Error: \$TEST_DEV is not set"
503         exit 1
504     fi
505     
506     if [ "`_fs_type $TEST_DEV`" != "xfs" ]
507     then
508         echo "common.rc: Error: \$TEST_DEV ($TEST_DEV) is not a MOUNTED XFS filesystem"
509         df -T $TEST_DEV
510         exit 1
511     fi
512
513 fi
514
515 # check for some required biunaries on our $PATH
516 #
517 for exec in mkfs.xfs xfs_logprint xfs_check xfs_repair xfs_db
518 do
519     if which $exec >/dev/null 2>&1 
520     then
521         :
522     else
523         echo "common.rc: cannot find $exec on \$PATH=$PATH"
524         exit 1
525     fi
526 done
527
528 # make sure this script returns success
529 /bin/true